#ifndef ACTION_H
#define ACTION_H

#include "console.h"

#include <string>

struct action {
    virtual void trigger() = 0;
};

struct action_terminal : action {
    std::string text;
    action_terminal(std::string text);
    void trigger();
};

struct action_console : action {
    struct console * console;
    std::string text;
    SDL_Renderer * renderer;
    action_console(struct console * console, SDL_Renderer * renderer, std::string text);
    void trigger();
};

#endif // ACTION_H
