#ifndef CRITERION_H
#define CRITERION_H

#include "unit.h"

struct criterion {
    virtual bool check(struct unit * unit) = 0;
};

/** Cristal **/

struct cristal_greather_equal : criterion {
    unsigned int threshold;
    cristal_greather_equal(unsigned int threshold);
    bool check(struct unit * unit);
};

struct cristal_less_equal : criterion {
    unsigned int threshold;
    cristal_less_equal(unsigned int threshold);
    bool check(struct unit * unit);
};

/** Power Gem **/

struct powergem_greather_equal : criterion {
    unsigned int threshold;
    powergem_greather_equal(unsigned int threshold);
    bool check(struct unit * unit);
};

struct powergem_less_equal : criterion {
    unsigned int threshold;
    powergem_less_equal(unsigned int threshold);
    bool check(struct unit * unit);
};

/** Energy **/

struct energy_greather_equal : criterion {
    unsigned int threshold;
    energy_greather_equal(unsigned int threshold);
    bool check(struct unit * unit);
};

struct energy_less_equal : criterion {
    unsigned int threshold;
    energy_less_equal(unsigned int threshold);
    bool check(struct unit * unit);
};

/** Model **/

struct model_is : criterion {
    struct model * model;
    model_is(struct model * model);
    bool check(struct unit * unit);
};

struct model_is_not : criterion {
    struct model * model;
    model_is_not(struct model * model);
    bool check(struct unit * unit);
};

#endif // CRITERION_H
