#include "menu.h"
#include "square.h"

menu::menu(SDL_Renderer * renderer, std::vector<struct model *> entries) :
    entries(entries),
    redcross(renderer, "data\\redcross.bmp")
{
}

struct model * menu::click(int x, int y) {
    if(x >= SCREEN_WIDTH && x <= WINDOW_WIDTH && y >= 0) {
        for(unsigned int i=0; i<this->entries.size(); i++) {
            if(y <= (signed) (i+1)*MENU_WIDTH) {
                return(this->entries.at(i));
            }
        }
    }
    return(NULL);
}

void menu::draw(SDL_Renderer * renderer, struct unit * builder) {
    float x = SCREEN_WIDTH+MENU_WIDTH/2;
    for(unsigned int i=0; i<this->entries.size(); i++) {
        float y = i*MENU_WIDTH+MENU_WIDTH/2;
        this->entries.at(i)->sprite.draw(renderer, x, y);
        if(!builder->can_build(this->entries.at(i))) {
            this->redcross.draw(renderer, x, y);
        }
    }
}
