#include <stdlib.h>

#include "randgen.h"

int count_alive_neighbour(int x, int y, cell matrix[GRID_WIDTH][GRID_HEIGHT]) {
    int nb_alive = 0;
    for(int dx = -1; dx <= +1; dx++) {
        for(int dy = -1; dy <= +1; dy++) {
            if(!(dx == 0 && dy == 0)) {
                int nx = x + dx;
                int ny = y + dy;
                if(nx >= 0 && nx < GRID_WIDTH && ny >= 0 && ny < GRID_HEIGHT) {
                    if(matrix[nx][ny]) {
                        nb_alive++;
                    }
                } else {
                    nb_alive++;
                }
            }
        }
    }
    return(nb_alive);
}

void white_noise(cell matrix[GRID_WIDTH][GRID_HEIGHT]) {
    for(int x=0; x<GRID_WIDTH; x++) {
        for(int y=0; y<GRID_HEIGHT; y++) {
            matrix[x][y] = rand()%2;
        }
    }
}

void cell_automat_smooth(cell matrix[GRID_WIDTH][GRID_HEIGHT], int nb_pass, int death_threshold, int birth_threshold) {
    cell next_matrix[GRID_WIDTH][GRID_HEIGHT];

    for(int k=0; k<nb_pass; k++) {

        for(int x=0; x<GRID_WIDTH; x++) {
            for(int y=0; y<GRID_HEIGHT; y++) {
                next_matrix[x][y] = matrix[x][y];
                int alive_neighbour = count_alive_neighbour(x, y, matrix);
                if(matrix[x][y]) { // If Alive
                    if(alive_neighbour < death_threshold) {
                        next_matrix[x][y] = false; // Die
                    }
                } else { // If Dead
                    if(alive_neighbour > birth_threshold) {
                        next_matrix[x][y] = true; // Birth
                    }
                }
            }
        }

        for(int x=0; x<GRID_WIDTH; x++) {
            for(int y=0; y<GRID_HEIGHT; y++) {
                matrix[x][y] = next_matrix[x][y];
            }
        }

    }
}

void increass(cell matrix[GRID_WIDTH][GRID_HEIGHT], int nb_pass, int ge_threshold) {
    cell next_matrix[GRID_WIDTH][GRID_HEIGHT];

    for(int k=0; k<nb_pass; k++) {

        for(int x=0; x<GRID_WIDTH; x++) {
            for(int y=0; y<GRID_HEIGHT; y++) {
                next_matrix[x][y] = matrix[x][y];
                int alive_neighbour = count_alive_neighbour(x, y, matrix);
                if(matrix[x][y]) { // If Alive
                    if(alive_neighbour >= ge_threshold) {
                        next_matrix[x][y]++;
                    }
                }
            }
        }

        for(int x=0; x<GRID_WIDTH; x++) {
            for(int y=0; y<GRID_HEIGHT; y++) {
                matrix[x][y] = next_matrix[x][y];
            }
        }

    }

}
