#include "sprite.h"

extern void error(std::string msg);

sprite::sprite(SDL_Renderer * renderer, const std::string filename) {
    SDL_Surface * surface = SDL_LoadBMP(filename.c_str());
    if(surface == NULL)
        error("Unable to load bmp file");
    this->texture = SDL_CreateTextureFromSurface(renderer, surface);
    if(texture == NULL)
        error("Unable to create texture from surface");
    this->rect.w = surface->w;
    this->rect.h = surface->h;
    SDL_FreeSurface(surface);
}

sprite::sprite(SDL_Renderer * renderer, SDL_Surface * surface) {
    this->texture = SDL_CreateTextureFromSurface(renderer, surface);
    if(texture == NULL)
        error("Unable to create texture from surface");
    this->rect.w = surface->w;
    this->rect.h = surface->h;
}

sprite::~sprite() {
    SDL_DestroyTexture(this->texture);
}

void sprite::draw(SDL_Renderer * renderer, float x, float y) {
    this->rect.x = x - this->rect.w/2;
    this->rect.y = y - this->rect.h/2;
    SDL_RenderCopy(renderer, this->texture, NULL, &(this->rect));
}
