#include "square.h"
#include "morphing.h"
#include "sizes.h"

square::square() {
    this->rock = 0;
    this->cristal = 0;
    this->powergem = 0;
    this->hard = false;
}

square::square(unsigned int rock) {
    this->rock = rock;
    this->cristal = 0;
    this->powergem = 0;
    this->hard = false;
}

bool square::is_passable() {
    return(this->rock <= 0);
}

void square::mine(struct unit * unit) {
    if(this->rock > 0) {
        if(unit->model->drill_power >= this->rock) {
            this->rock = 0;
        } else {
            this->rock -= unit->model->drill_power;
        }
    }
    if(this->cristal > 0 && this->rock <= 0) {
        unsigned int transfert = std::min(unit->cristal->free_space(), this->cristal);
        this->cristal -= transfert;
        unit->cristal->increase(transfert);
    }
    if(this->powergem > 0 && this->rock <= 0) {
        unsigned int transfert = std::min(unit->powergem->free_space(), this->powergem);
        this->powergem -= transfert;
        unit->powergem->increase(transfert);
    }
}

void square::draw(SDL_Renderer * renderer, unsigned int x, unsigned int y) {
    extern struct morphing * morphing_rock;
    extern struct morphing * morphing_hard_rock;
    extern struct morphing * morphing_cristal;
    extern struct morphing * morphing_powergem;
    float nx = x * SQUARE_SIZE + SQUARE_SIZE/2;
    float ny = y * SQUARE_SIZE + SQUARE_SIZE/2;
    if(this->powergem > 0) {
        morphing_powergem->draw(renderer, nx, ny, this->rock);
    } else if(this->cristal > 0) {
        morphing_cristal->draw(renderer, nx, ny, this->rock);
    } else if(this->hard) {
        morphing_hard_rock->draw(renderer, nx, ny, this->rock);
    } else {
        morphing_rock->draw(renderer, nx, ny, this->rock);
    }
}
