#ifndef UNIT_H
#define UNIT_H

#include "model.h"
#include "gauge.h"
#include "square.h"
#include "sizes.h"

#include <forward_list>

#define COLLECT_DISTANCE 20
#define ENERGY_GENERATOR_THRESHOLD 100000

struct unit {
    struct model * model;
    float x;
    float y;
    float target_x;
    float target_y;
    struct gauge * energy;
    struct gauge * cristal;
    struct gauge * powergem;
    unsigned int energy_accumulator;

    unit(struct model * model, float x, float y);
    ~unit();
    void draw(SDL_Renderer * renderer);
    bool can_build(struct model * model);
    void set_position(float x, float y);
    void move(float dx, float dy, struct square grid[GRID_WIDTH][GRID_HEIGHT]);
    void move_toward(float x, float y, struct square grid[GRID_WIDTH][GRID_HEIGHT]);
    void mine(struct square grid[GRID_WIDTH][GRID_HEIGHT]);
    void build(struct model * model, float x, float y, std::forward_list<struct unit *> * units);
    void cycle(std::forward_list<struct unit *> * units, struct square grid[GRID_WIDTH][GRID_HEIGHT]);
    float distance(struct unit * unit);
    float distance(float x, float y);
};

#endif // UNIT_H
